/******************************************************************************/
//    File Name     : Olds.java
//                            Java Applet source file
//    Name          : Yoshiyuki Tanaka
//                    (e-Mail : tanaka_y@jaist.ac.jp)
//    Class Name    :     1.Olds()
/******************************************************************************/
/******************************************************************************/
//                                  IMPORT
/******************************************************************************/
import java.awt.*;

/******************************************************************************/
//    Class Name    : Olds
/******************************************************************************/
public class Olds
{
    /***** VALUE DATA *****/
    protected static Dimension     dim   = new Dimension(200, 200);
    protected static OldParam      param = new OldParam();
    protected static int           time  = 0;
    public    static Old[][]       cell  = new Old[dim.height][dim.width];
    protected        Old[][]       buff  = new Old[2][dim.width];

    /***** CONSTRUCTOR *****/
    public Olds()
    {
        for(int i = 0; i < cell.length; i++)
            for(int j = 0; j < cell[i].length; cell[i][j++] = new Old() );
        for(int i = 0; i < 2; i++)
            for( int j = 0; j < dim.width;     buff[i][j++] = new Old() );
    }

    /** INSTANCE METHOD **/
    /**************************************************************************/
    //    Method Name   : reset()
    /**************************************************************************/
    public void reset(){
        for(int i = 0; i < cell.length; i++)
            for(int j = 0; j < cell[i].length; cell[i][j++].reset() );
        time = 0;
    }

    /**************************************************************************/
    //    Method Name   : grow()
    /**************************************************************************/
    public void grow(){
        int k = 0;
        for(int i = 0; i < cell.length; i++)
            for( int j = 0; j < cell[i].length; cell[i][j++].step() );

        for(int i = 0; i < cell.length; i++){
            for(int j = 0; j < cell[i].length; j++){
                int v = 0;
                if( cell[i][j].checkRest() ){
                    if(0 < i)
                        if( cell[i - 1][j].checkExcited() ) v++;
                    if(0 < j)
                        if( cell[i][j - 1].checkExcited() ) v++;
                    if(i < cell.length - 1)
                        if( cell[i + 1][j].checkExcited() ) v++;
                    if(j < cell[i].length - 1)
                        if( cell[i][j + 1].checkExcited() ) v++;
                }
                buff[k][j].setCell( cell[i][j].renewalState(v) );
            }
            k = (k > 0)?(0):(1);
            if(0 < i)
                for(int j = 0; j < cell[i - 1].length; j++)
                    cell[i - 1][j].setCell(buff[k][j]);
        }
        k = (k > 0)?(0):(1);
        for(int j = 0; j < cell[cell.length - 1].length; j++)
            cell[cell.length - 1][j].setCell(buff[k][j]);
        this.time++;
    }

    /**************************************************************************/
    //    Method Name   : getdim()
    //    Method Name   : gettime()
    /**************************************************************************/
    public Dimension getdim() { return dim ;}
    public int       gettime(){ return time ;}

}


/**** END_of_file: Olds.java *************************************************/
